"""Test of traffic density metrics.
"""

import unittest

from de4l_geodata.geodata.route import Route
from de4l_geodata.geodata.point import Point, get_distance

import de4l_privacy_services.services.metrics.traffic_density as td


class TestTrafficDensity(unittest.TestCase):
    """Test of traffic density.
    """

    def setUp(self) -> None:
        route_1 = Route([Point([0, 0], geo_reference_system='cartesian', coordinates_unit='radians'),
                         Point([0.9, 0], geo_reference_system='cartesian', coordinates_unit='radians'),
                         Point([1.9, 0.9], geo_reference_system='cartesian', coordinates_unit='radians')]).to_latlon()
        input_route_1 = Route([Point([0, 0.4], geo_reference_system='cartesian', coordinates_unit='radians'),
                                     Point([1.4, 0.4], geo_reference_system='cartesian', coordinates_unit='radians'),
                                     Point([2.9, 1.9], geo_reference_system='cartesian', coordinates_unit='radians')
                                     ]).to_latlon()
        p1 = Point([0.5, 2.5], geo_reference_system='cartesian', coordinates_unit='radians')
        p2 = Point([1.5, 2.5], geo_reference_system='cartesian', coordinates_unit='radians')
        p3 = Point([1.5, 1.5], geo_reference_system='cartesian', coordinates_unit='radians')
        p4 = Point([0.6, 2.6], geo_reference_system='cartesian', coordinates_unit='radians')
        p5 = Point([2.5, 1.5], geo_reference_system='cartesian', coordinates_unit='radians')
        p6 = Point([2.5, 2.5], geo_reference_system='cartesian', coordinates_unit='radians')
        route_2 = Route([p1, p2, p2, p2, p2, p2, p3, p3, p3]).to_latlon()
        input_route_2 = Route([p4, p6, p6, p6, p6, p2, p2, p5]).to_latlon()
        self.grid_origin = route_1[0]
        extended_point = Point([3, 0], geo_reference_system='cartesian', coordinates_unit='radians').to_latlon()
        self.grid_width = get_distance(self.grid_origin, extended_point)
        self.width_per_cell = self.grid_width / 3.
        self.desired_point_count = 10
        self.ground_truth_routes = [route_1]
        self.input_routes = [input_route_1]
        self.ground_truth_routes_2 = [route_1, route_2]
        self.input_routes_2 = [input_route_1, input_route_2]
        self.empty_routes = [Route(), Route()]
        self.ground_truth_routes_3 = [
            Route([[-8.611954291776215, 41.150026226458486], [-8.611399043586, 41.15109916641347], [-8.61102221748332, 41.14866123223782], [-8.611932224883057, 41.148255784100535], [-8.610832314295244, 41.148710420931344], [-8.615843261076975, 41.149860868315514], [-8.612471871944587, 41.14699227202355], [-8.612888199384896, 41.146503808245534], [-8.612833725812761, 41.14590739517432], [-8.611170018360625, 41.14551388357905], [-8.61019180895611, 41.14463211672912], [-8.611246322907228, 41.144584074209426], [-8.609724976591963, 41.14357536858782], [-8.6093946035091, 41.143125434614795], [-8.608211271662421, 41.143787474133354], [-8.60463315987488, 41.14177685390425], [-8.604618786363561, 41.1454998166597], [-8.604413322257967, 41.1455186912394], [-8.606707640438787, 41.14437987837332], [-8.603384030999793, 41.14367651278802], [-8.602210081152702, 41.145691968273816], [-8.600407698533145, 41.14386009260712], [-8.597383157488277, 41.14399860037229], [-8.59888145859894, 41.14368770745385], [-8.59887410415828, 41.14651717268936], [-8.5984204518505, 41.14621824247863], [-8.601555921025371, 41.144933246916096], [-8.600422856128747, 41.14871488450867], [-8.603003798588901, 41.14555477301565], [-8.604214526203888, 41.14432413261556], [-8.603931018663669, 41.14433190829399], [-8.604197646079104, 41.14472054312367], [-8.60366178942494, 41.14464746309769], [-8.603656806132172, 41.14536181265091], [-8.605115173699577, 41.14535738839062], [-8.603887688151426, 41.14655509039743], [-8.60270913191106, 41.14564647798984], [-8.602924539282876, 41.14556248932239], [-8.60290086316869, 41.146213537009665], [-8.602179236692264, 41.1443130773224], [-8.602263823317358, 41.14635020531307], [-8.60129802245458, 41.14743364738416], [-8.60189329236453, 41.14796463841639], [-8.602263880402056, 41.14843778823826], [-8.602276340656456, 41.15315822846353], [-8.600908334261744, 41.1578035030657], [-8.601777889425835, 41.15420828789069], [-8.603780978668949, 41.15300933030801], [-8.603957392378591, 41.15140334902608], [-8.604211027571347, 41.152076864367054], [-8.603850269374949, 41.149192973097556], [-8.602798051079194, 41.1499899580328], [-8.606038049813574, 41.14936695069705], [-8.606024693282427, 41.149041781615104], [-8.610099307400594, 41.15136814320251], [-8.605198561113069, 41.14976667437053], [-8.60789225152054, 41.15020087675952], [-8.608000269522192, 41.14971784355544], [-8.608011304370658, 41.14921610827592], [-8.604850746355135, 41.14568295780573], [-8.60712779138652, 41.14871408998348], [-8.607041162164629, 41.14916803528798], [-8.60857288989658, 41.14969761065354], [-8.60741396154819, 41.14644869141076], [-8.609206613138873, 41.14723643679348], [-8.612386323000791, 41.148003395251536], [-8.612683816406731, 41.14761484867129], [-8.611663256133895, 41.14617370244666], [-8.610934422335529, 41.14553076522279], [-8.610218924000009, 41.14702156790397], [-8.610759330999967, 41.14653280933509], [-8.610947125047327, 41.146461774578256], [-8.611118967222573, 41.14490293096907], [-8.61296005730334, 41.144999433106356], [-8.61093477051945, 41.1448871421591], [-8.61461172317698, 41.142530452327726], [-8.61124643876369, 41.14479144945152], [-8.61046998344188, 41.146114063757494], [-8.609313957568153, 41.145742694505124], [-8.609473239269567, 41.14731734110183], [-8.608162689584491, 41.14635488868472], [-8.608832306734206, 41.146512902759135], [-8.612057614251508, 41.14778507583997], [-8.607207690854844, 41.146907591966524], [-8.607164985908652, 41.14840711839074], [-8.606442431443973, 41.14927207115404], [-8.606096599945188, 41.1498300548378], [-8.606838186688066, 41.14850832839111], [-8.605305959470103, 41.1475797799023], [-8.605958023618413, 41.14846274920446], [-8.60362310428563, 41.14793120111926], [-8.601933675735314, 41.14812816522763], [-8.603416729461637, 41.14698390685131], [-8.602919059746021, 41.146786887544394], [-8.606524882852995, 41.15079759972435], [-8.605170829961734, 41.15085854129794], [-8.604853694902653, 41.149409095137386], [-8.60280119311751, 41.147142370808936], [-8.605753798747811, 41.145295474042264], [-8.603538371825639, 41.14594122982929], [-8.605282489453723, 41.14707193357669], [-8.605664002253949, 41.14588127802924], [-8.607083348077783, 41.14674214698157], [-8.605274765588023, 41.14697588019295], [-8.60627454028637, 41.14810849209929], [-8.604495500760638, 41.14719208716854], [-8.607977325857282, 41.147579560920704], [-8.609120628149682, 41.14704648820011], [-8.608081570326524, 41.14767979911733], [-8.607885401989627, 41.14748627457941], [-8.610626333574444, 41.14920572802606], [-8.609105041363517, 41.147583244147306], [-8.609005217059915, 41.14686131618355], [-8.609818183169281, 41.14928686409946], [-8.611044635711439, 41.14724000558623], [-8.611042761029916, 41.1459373263146], [-8.61143892689003, 41.146967861597425], [-8.612611020325518, 41.14470784270322], [-8.610066693670356, 41.14677278733284], [-8.610911289422118, 41.146227553891904], [-8.607798852408623, 41.14647277303569], [-8.608913337149865, 41.14628203499664], [-8.60755529711485, 41.14925689528856], [-8.608332961573325, 41.14899219877797], [-8.606248213454656, 41.147649799865626], [-8.607249427833063, 41.1480684687286], [-8.606351688819162, 41.148652365928015], [-8.600495713298288, 41.14752368941718], [-8.604137180551714, 41.14680190827544], [-8.603462249208494, 41.14714991537803], [-8.60739605418526, 41.1478418432337], [-8.602959774290206, 41.14627570344386], [-8.603892825099592, 41.14747995033917], [-8.603715176441838, 41.145194339439065], [-8.60626435954131, 41.14429160871289], [-8.606754716087753, 41.14564443779579], [-8.610247255095455, 41.14578397657861], [-8.605232238059175, 41.147444338458385], [-8.607022505959081, 41.14496716712799], [-8.607232031012463, 41.145526426577206], [-8.607658386916132, 41.14610793377914], [-8.609111592028036, 41.14535773381345], [-8.610837121851528, 41.146518616927004], [-8.60720415073637, 41.1456132911115], [-8.606721074479594, 41.14578432443057], [-8.607173604975713, 41.14541975023761], [-8.607919734047659, 41.14572709162964], [-8.607003154260164, 41.14631895682724], [-8.605426700528826, 41.14621007075595], [-8.606027556369, 41.14722327099831], [-8.609263506327498, 41.147303553438945], [-8.608486846008098, 41.14686839728342], [-8.60799274077645, 41.148518079107525], [-8.606192636591764, 41.150330496066864], [-8.608724760023684, 41.1501757793638], [-8.60567549333848, 41.15087972890517], [-8.605035297551282, 41.15235513096765], [-8.603476907699955, 41.15359414082814], [-8.604737786288233, 41.1543101091128], [-8.60566947177516, 41.155376446845835], [-8.604082188845341, 41.15732083288862], [-8.603365823081061, 41.15902108779416], [-8.599933025354455, 41.16101172827571], [-8.599586464686384, 41.159949768814315], [-8.594658288841357, 41.156853276149356], [-8.595629912963279, 41.160097894413646], [-8.591772757054159, 41.16167176422179], [-8.589840166863606, 41.164642258076114], [-8.588933033386008, 41.16346920000788], [-8.58872256383531, 41.16417538307132], [-8.589383717612883, 41.16806457630151], [-8.586794256393134, 41.170327499558425], [-8.585810119082, 41.17325415883859], [-8.586170398039748, 41.173532437880624], [-8.58290507780302, 41.175130190354075], [-8.579743581925381, 41.17764480574413], [-8.575691482510766, 41.17805956038298], [-8.575922540780383, 41.17678738029363], [-8.574620018496656, 41.17380663587469], [-8.574293000578484, 41.17445141446112], [-8.57294126807509, 41.173613120685935], [-8.573425960536275, 41.17487171870172], [-8.571449292907337, 41.17336156731496], [-8.574147543164099, 41.1727438471484], [-8.574992904563818, 41.17039606181772], [-8.575555935186719, 41.17210239744292], [-8.572519703950324, 41.16925730633404], [-8.573812794527022, 41.16999115869058], [-8.572521706135856, 41.1709354799387], [-8.573593104728754, 41.16976294983974], [-8.573977893789351, 41.172989321927226], [-8.573317108814345, 41.17192620904085], [-8.574658981633036, 41.17308399605011], [-8.575934383292287, 41.17368457868429], [-8.575121936272447, 41.17324335545058], [-8.571245792186238, 41.174512086912074], [-8.574174616161065, 41.17467444146116], [-8.573242954433846, 41.173601633823125], [-8.579215811636793, 41.17349078711749], [-8.576899185401151, 41.17253185988972], [-8.575649810272358, 41.173857920698936], [-8.575779965833902, 41.17360262987933], [-8.577702198812757, 41.171382175098444], [-8.576990351439315, 41.17489011359325], [-8.577964224281587, 41.17280629403129], [-8.578199446243937, 41.17326634229395], [-8.576770168040436, 41.1737516114799], [-8.578591581130624, 41.17315619501319], [-8.577906352479136, 41.17305686374276], [-8.581324343510612, 41.170334408671984], [-8.581604201733482, 41.169997381914065], [-8.578443952375371, 41.16614293810223], [-8.579462858084174, 41.168132936219216], [-8.580514305544664, 41.1680305775534], [-8.580535519003604, 41.16782825664427], [-8.57739161959451, 41.1683389752147], [-8.579714677323611, 41.167843876151665], [-8.580713665935603, 41.16989869879891], [-8.581904606299798, 41.169950447857815], [-8.581373306219922, 41.171673300635476], [-8.580523217759126, 41.16951470187119], [-8.584724326463052, 41.16993283566565], [-8.587259957899207, 41.17014438198121], [-8.58307727248072, 41.16970252440116], [-8.587133721249716, 41.17090020532524], [-8.58983023637151, 41.17009615600672], [-8.586532353010988, 41.174269430007996], [-8.587468083023865, 41.17527610921106], [-8.584313827578299, 41.17952261892021], [-8.583326495051095, 41.18115502016179], [-8.583908195323673, 41.181090392119195], [-8.583845971893837, 41.17997716274952], [-8.582932973013268, 41.18010516520892], [-8.581135149480076, 41.179292415310904], [-8.583307631145656, 41.17649825541986], [-8.584688365436866, 41.17608022030948], [-8.584862129859772, 41.172813441887826], [-8.58434231871661, 41.173009094438385], [-8.584846682299156, 41.17233074672405], [-8.585051658719463, 41.172449060362595], [-8.58280335565847, 41.17106027658973]], coordinates_unit='degrees'),
            Route([[-8.641096349232873, 41.15863194436724], [-8.640614131763009, 41.16114292144784], [-8.642166761714284, 41.16009450262546], [-8.644952190797465, 41.16140833743479], [-8.645002450864087, 41.15996366914297], [-8.650185792913925, 41.160861083490154], [-8.653054709795011, 41.162385878749035], [-8.657283194688357, 41.16180365789102], [-8.660514502199323, 41.16395295841752], [-8.663047923668735, 41.16391961164819], [-8.666002310117555, 41.16506799145003], [-8.669172079561807, 41.1633924131077], [-8.67062884137168, 41.16493685126248], [-8.66975345867429, 41.167591584826354], [-8.669459148828528, 41.16871280419088], [-8.671094944550566, 41.170546271122305], [-8.666687099404063, 41.170328372461796], [-8.666715109505004, 41.1721296817333], [-8.66574257335969, 41.17067389424955], [-8.66499906656633, 41.171731029494836], [-8.666489260495117, 41.17077895805], [-8.665859929273864, 41.17094206372407], [-8.662617171354661, 41.17635807285881], [-8.661440788077702, 41.174120653363694], [-8.660654234835325, 41.177379342728685], [-8.663652889927096, 41.17632478172024], [-8.663453706362173, 41.17823689661407], [-8.661707715106987, 41.17839837498709], [-8.662326715520233, 41.178136388788026], [-8.66456837338523, 41.178225160351836], [-8.661677432404765, 41.17712125437958], [-8.660620459973323, 41.175846650899004], [-8.660401356775902, 41.17716206845331], [-8.655505185178187, 41.177888484427406], [-8.653201582419033, 41.177871686791825], [-8.652354727229621, 41.17895887992205], [-8.652755053424617, 41.18024127727005], [-8.652240055901148, 41.18276495111699], [-8.652954482034332, 41.18319953416277], [-8.655123031541686, 41.18472770464573], [-8.654042705754167, 41.18662994987602], [-8.654856283767751, 41.18836527996669], [-8.654982807061145, 41.18722039598802], [-8.653476898162918, 41.187746542463756]], coordinates_unit='degrees'),
            Route([[-8.616528162708002, 41.143108767796754], [-8.619384752671273, 41.141114403417845], [-8.62035603788652, 41.142530519549844], [-8.621581386071696, 41.143793251885846], [-8.622389955253624, 41.14536529865918], [-8.62897852675838, 41.146802312124], [-8.627053949125605, 41.14483778302328], [-8.630366662433099, 41.145748090546334], [-8.630337121389413, 41.14957161463632], [-8.631323127120194, 41.14833603584296], [-8.628853372075374, 41.15096251563718], [-8.630460991403941, 41.15030590687508], [-8.629316228436766, 41.15138270040068], [-8.62852134770796, 41.15130399320553], [-8.628409495903146, 41.152594564287156], [-8.628757739648085, 41.152617345103444], [-8.629535086248644, 41.15260649648501], [-8.633105964172033, 41.15287526532824], [-8.631467569933259, 41.15434089998568], [-8.6298904318294, 41.15396558887861], [-8.631976119835768, 41.155855493624856], [-8.63162274908757, 41.1541275600636], [-8.631039142421965, 41.15708022477034], [-8.630801079162337, 41.15409266718758], [-8.631975781340886, 41.15443165914606], [-8.63144047421105, 41.154735541557244], [-8.628134843743473, 41.15539715341805], [-8.632238103050753, 41.155450612479854], [-8.632529954029842, 41.1552848623886], [-8.632745397646648, 41.15374644486273], [-8.63247461308523, 41.15364686962776], [-8.634995398976466, 41.152843565039035], [-8.6392781407332, 41.150487907190374], [-8.642787665207388, 41.149793536277755], [-8.647254651470526, 41.1512813781321], [-8.642426870590738, 41.15170720304832], [-8.640404918021401, 41.14945661528152], [-8.63752158945929, 41.14697092228192], [-8.640398596679049, 41.1443598821071], [-8.640743300612984, 41.142413762911886], [-8.64173020038374, 41.1426343165347], [-8.64222202414245, 41.141443182781146], [-8.642415816786777, 41.141433232561994], [-8.641674504853897, 41.14099657375655], [-8.643124950034542, 41.14057749184454], [-8.642147165337688, 41.140006978305756], [-8.642691486830103, 41.14040361288328], [-8.639818546217281, 41.14026931133759], [-8.640169025396911, 41.14118325071797], [-8.641508308535718, 41.14125549795927], [-8.64346470649822, 41.140285203068906], [-8.646447282307909, 41.14144838042499], [-8.64762094348623, 41.14219089886405], [-8.64710647680039, 41.142736153119984], [-8.648978752950674, 41.142558115680636], [-8.647485708507409, 41.14182955895913], [-8.64725520827339, 41.14248291708343], [-8.647354296338225, 41.14127294872295], [-8.648618087372741, 41.14347166748361], [-8.648842877124284, 41.14213246731979], [-8.647186488897297, 41.14271403819228], [-8.650761787481882, 41.14253972411571]], coordinates_unit='degrees')
        ]
        self.input_routes_3 = [
            Route([[-8.61147, 41.150376], [-8.611893, 41.150313], [-8.612199, 41.149503], [-8.612217, 41.148549], [-8.612964, 41.148261], [-8.614341, 41.148333], [-8.614251, 41.14782], [-8.613639, 41.14615500000001], [-8.612244, 41.146173], [-8.61129, 41.14615500000001], [-8.610984, 41.145021], [-8.610498000000002, 41.14355400000001], [-8.610084, 41.143239], [-8.608545, 41.143059], [-8.608203, 41.142924], [-8.606007, 41.14238400000001], [-8.604936, 41.143932], [-8.604351, 41.145093], [-8.604315, 41.145174], [-8.603478, 41.145471], [-8.60301, 41.14557], [-8.601363, 41.145336], [-8.599725, 41.144148], [-8.599419, 41.144094], [-8.598186, 41.145633], [-8.599027296912114, 41.1458956888361], [-8.601388396363637, 41.14572087272728], [-8.601711026785715, 41.145711428571424], [-8.603706614173229, 41.14549016929134], [-8.604401177257525, 41.145134056856186], [-8.603446173913044, 41.14551839130435], [-8.604194254658385, 41.14535070186336], [-8.604251341463415, 41.14542358536585], [-8.604580977272727, 41.14529423863637], [-8.604436757142858, 41.14493742857143], [-8.603031333333334, 41.14554361111111], [-8.60307688235294, 41.145581647058826], [-8.603228076923077, 41.14558073076924], [-8.602425520231213, 41.14578508959538], [-8.602064565517242, 41.1456402], [-8.601715665671641, 41.1459823880597], [-8.601935818965517, 41.14690975862067], [-8.602099824489796, 41.1487367877551], [-8.6026455, 41.149817826923076], [-8.60243670967742, 41.15357477419355], [-8.602514872340429, 41.15534936170213], [-8.60291382, 41.1548396], [-8.603466749999999, 41.15326275], [-8.60411659090909, 41.15177959090909], [-8.604463772093023, 41.15094639069768], [-8.604165438202246, 41.15011853932584], [-8.603977923913043, 41.14948666304348], [-8.604926458646617, 41.149677248120305], [-8.6049975, 41.149612499999996], [-8.605889608695652, 41.149828956521745], [-8.606721986577183, 41.150045416107375], [-8.60700853960396, 41.15012783168317], [-8.607227478260867, 41.14994386956522], [-8.60771333121019, 41.14916237579617], [-8.60781295862069, 41.14889255172414], [-8.607964400881057, 41.14848422577093], [-8.607969118421053, 41.14823234210526], [-8.608176769736843, 41.14793445394737], [-8.608437616071429, 41.14747083482142], [-8.609917135394456, 41.147751434968015], [-8.61054429645094, 41.14788479436326], [-8.611205457446808, 41.14712810106384], [-8.611411488431877, 41.146578277634966], [-8.611470093264249, 41.146175308290154], [-8.611434433299898, 41.14594719658977], [-8.611474436619718, 41.146045288732395], [-8.611147382681564, 41.14605660335196], [-8.610862599264708, 41.145973113970584], [-8.610943707236842, 41.14533080427632], [-8.611424574803149, 41.14475900787403], [-8.611339013513515, 41.14473287837838], [-8.611069142045455, 41.1451925625], [-8.61063084860558, 41.14603018326694], [-8.60998544628099, 41.14633693388429], [-8.609271389312976, 41.14671842748091], [-8.609123228571429, 41.14669791428571], [-8.608796513513512, 41.14692340540542], [-8.608745892857144, 41.14709807142857], [-8.608539202846975, 41.14730123487545], [-8.607346968973747, 41.14913838902147], [-8.606830153846152, 41.14913884615385], [-8.606961, 41.148867599999996], [-8.607003607594939, 41.14859684810127], [-8.60639216666667, 41.1484075], [-8.606018647058825, 41.14823537647059], [-8.605362272727273, 41.147958974025975], [-8.604769280487805, 41.14779003658537], [-8.603092862068966, 41.14733927586207], [-8.6028804, 41.147937], [-8.602923272727274, 41.14910427272727], [-8.60420408108108, 41.14948937837838], [-8.60419377777778, 41.14933011111111], [-8.603921605263157, 41.147601039473685], [-8.603885, 41.14646209090908], [-8.605068827586207, 41.14670694827586], [-8.605316543478262, 41.146735891304346], [-8.606093625000002, 41.146916062500004], [-8.607067101818183, 41.14697730545455], [-8.606832579831934, 41.14694488235293], [-8.60670623076923, 41.146895565610855], [-8.60756837837838, 41.14705767567568], [-8.6080704, 41.14727980000001], [-8.608958839694658, 41.147430034351146], [-8.608730069620254, 41.147880892405055], [-8.608453287096774, 41.1480119032258], [-8.60869964516129, 41.147648419354844], [-8.609137099378882, 41.147615683229816], [-8.6095815, 41.14755103448275], [-8.610958752475248, 41.14765312871287], [-8.611184172413793, 41.14650336206897], [-8.611441139240506, 41.14633894936709], [-8.611128, 41.14615109433962], [-8.610811615384616, 41.145800625], [-8.610235945945945, 41.14636256756757], [-8.609254158663882, 41.14688999373695], [-8.608918338129497, 41.146852953237406], [-8.608722582089552, 41.14698380597015], [-8.608355105590062, 41.14779149068323], [-8.6072175, 41.149263477272726], [-8.607029875, 41.148452250000005], [-8.606894727272728, 41.148432440559446], [-8.6064165, 41.148223200000004], [-8.602777923076923, 41.14738776923077], [-8.602626112149531, 41.14721691588785], [-8.6023755, 41.14717681034484], [-8.601734093023255, 41.14718168023256], [-8.602080403846154, 41.147024884615384], [-8.6027895, 41.146759125], [-8.604297, 41.14623027272727], [-8.606765240816326, 41.144864840816325], [-8.607110435207826, 41.1451230806846], [-8.607319761467892, 41.14551075688073], [-8.607249000000001, 41.14566], [-8.60724, 41.145651], [-8.607222, 41.14566], [-8.607222, 41.14566], [-8.607195, 41.145642], [-8.607204, 41.145642], [-8.607213, 41.145642], [-8.60724, 41.145642], [-8.60715, 41.145615], [-8.607069, 41.14575], [-8.606862, 41.146605], [-8.606799, 41.146848000000006], [-8.607321, 41.147082], [-8.608662, 41.147244], [-8.608743000000002, 41.147388], [-8.608014, 41.148315], [-8.60742, 41.14953], [-8.607303000000002, 41.14989], [-8.606511, 41.150943], [-8.605287, 41.15268], [-8.604855, 41.153814], [-8.604765, 41.154381], [-8.604738, 41.155713], [-8.604585, 41.157738], [-8.60445, 41.159862], [-8.602488, 41.159727], [-8.599716, 41.159124], [-8.597385, 41.159331], [-8.594541, 41.160231], [-8.591121, 41.162049], [-8.589699, 41.163741], [-8.58969, 41.163777], [-8.589033, 41.164794], [-8.588016, 41.167305], [-8.58672, 41.169969], [-8.585208, 41.172894], [-8.583894, 41.174163], [-8.582175000000001, 41.175306], [-8.579547, 41.177016], [-8.576784, 41.177799], [-8.574903, 41.177403], [-8.575776, 41.175423], [-8.575362000000002, 41.174253], [-8.573949, 41.174082], [-8.572896, 41.174244], [-8.572626, 41.174316000000005], [-8.573832, 41.173173], [-8.572914, 41.172273], [-8.573958, 41.171616], [-8.573931, 41.170779], [-8.573463, 41.170833], [-8.573499000000002, 41.170851], [-8.574003, 41.170617], [-8.573634, 41.171724], [-8.573328, 41.172111], [-8.5734, 41.172876], [-8.572995, 41.173911], [-8.572518, 41.174559], [-8.573778, 41.174262], [-8.575398, 41.174298], [-8.576316, 41.174028], [-8.577414, 41.17311], [-8.577612, 41.173038], [-8.577612, 41.173047], [-8.577612, 41.173029], [-8.577603, 41.17302], [-8.577603, 41.173029], [-8.577594, 41.173038], [-8.577585, 41.173047], [-8.57763, 41.173029], [-8.57763, 41.17302], [-8.578287, 41.172453000000004], [-8.578971, 41.171679], [-8.578593, 41.170824], [-8.57934, 41.169465], [-8.579826, 41.168259], [-8.579853, 41.168286], [-8.579862, 41.168277], [-8.579907, 41.168133], [-8.581104, 41.168664], [-8.581329, 41.169915], [-8.581509, 41.170779], [-8.582445, 41.171274], [-8.583552, 41.170392], [-8.585127, 41.170203], [-8.586288, 41.170554], [-8.586297, 41.170563], [-8.587611, 41.170923], [-8.588034000000002, 41.171634], [-8.586657, 41.174091], [-8.585361, 41.176701], [-8.583885, 41.179248], [-8.583066, 41.180931], [-8.582499, 41.180679], [-8.582553, 41.180535], [-8.582211, 41.180238], [-8.582625, 41.178501], [-8.583588, 41.176251], [-8.584407, 41.174334], [-8.58366, 41.173614], [-8.584236, 41.172507], [-8.58366, 41.172228], [-8.582895, 41.172183], [-8.582445, 41.17123800000001]], coordinates_unit='degrees'),
            Route([[-8.639847, 41.159826], [-8.640351, 41.159871], [-8.642196, 41.160114], [-8.644455, 41.160492], [-8.646921, 41.160951], [-8.649999, 41.161491], [-8.653167, 41.162031], [-8.656434, 41.16258], [-8.660178, 41.163192], [-8.663112, 41.163687], [-8.666235, 41.1642], [-8.669169, 41.164704], [-8.670852, 41.165136], [-8.670942, 41.166576], [-8.66961, 41.167962], [-8.668098, 41.168988000000006], [-8.66664, 41.170005], [-8.665767, 41.170635000000004], [-8.66574, 41.170671], [-8.665686, 41.170626], [-8.665677, 41.170653], [-8.664786, 41.171319], [-8.663238, 41.172453000000004], [-8.66205, 41.173875], [-8.662248, 41.175378], [-8.663733, 41.176413], [-8.663751, 41.17725], [-8.663229, 41.177754], [-8.66322, 41.177763], [-8.66322, 41.177763], [-8.662986, 41.17779], [-8.661771, 41.176773], [-8.6589, 41.177169], [-8.656083, 41.177772], [-8.65512, 41.177898], [-8.653248, 41.178708], [-8.652699, 41.180409], [-8.653203, 41.182677000000005], [-8.653302, 41.183631000000005], [-8.653806, 41.185359], [-8.654166, 41.18697], [-8.654328, 41.187816], [-8.654337, 41.187816], [-8.654337, 41.187816]], coordinates_unit='degrees'),
            Route([[-8.618643, 41.141412], [-8.618499, 41.141376], [-8.620326, 41.14251], [-8.622153, 41.143815], [-8.623953, 41.144373], [-8.62668, 41.144778], [-8.627373, 41.144697], [-8.630226, 41.14521], [-8.632746, 41.14692], [-8.631738, 41.148225], [-8.629938, 41.150385], [-8.62911, 41.151213], [-8.629128, 41.15124], [-8.628786, 41.152203], [-8.628687, 41.152374], [-8.628759, 41.152518], [-8.630838000000002, 41.15268], [-8.632323000000001, 41.153022], [-8.631144, 41.154489], [-8.630829, 41.154507], [-8.630829, 41.15451600000001], [-8.630829, 41.154498], [-8.630838000000002, 41.154489], [-8.630784, 41.154795], [-8.631135, 41.154534], [-8.631126, 41.154543], [-8.631099, 41.154552], [-8.631108, 41.15457], [-8.631108, 41.154579], [-8.63145, 41.154309], [-8.632548, 41.152491], [-8.634888, 41.151186], [-8.638344, 41.150133], [-8.642457, 41.149431], [-8.644725, 41.151294], [-8.642484, 41.15151], [-8.640918, 41.149458], [-8.640198, 41.146614], [-8.639622, 41.143923], [-8.641062, 41.142627], [-8.641953, 41.142564], [-8.642142, 41.141376], [-8.642295, 41.140872], [-8.642304, 41.140872], [-8.642304, 41.140881], [-8.642304, 41.140881], [-8.642295, 41.140881], [-8.642295, 41.140881], [-8.642304, 41.1408], [-8.642817000000003, 41.140053], [-8.644302000000001, 41.140341], [-8.646003, 41.141169], [-8.647506, 41.142267], [-8.647776, 41.142465], [-8.647794, 41.142501], [-8.647821, 41.142537], [-8.647893, 41.142618], [-8.647857, 41.142618], [-8.647857, 41.142618], [-8.647857, 41.142609], [-8.647866, 41.142618], [-8.647875, 41.142609]], coordinates_unit='degrees')
        ]
        self.input_routes_3_more_points = [
            Route([[-8.61147, 41.150376], [-8.611893, 41.150313], [-8.612199, 41.149503], [-8.612217, 41.148549], [-8.612964, 41.148261], [-8.614341, 41.148333], [-8.614251, 41.14782], [-8.613639, 41.14615500000001], [-8.612244, 41.146173], [-8.61129, 41.14615500000001], [-8.610984, 41.145021], [-8.610498000000002, 41.14355400000001], [-8.610084, 41.143239], [-8.608545, 41.143059], [-8.608203, 41.142924], [-8.606007, 41.14238400000001], [-8.604936, 41.143932], [-8.604351, 41.145093], [-8.604315, 41.145174], [-8.603478, 41.145471], [-8.60301, 41.14557], [-8.601363, 41.145336], [-8.599725, 41.144148], [-8.599419, 41.144094], [-8.598186, 41.145633], [-8.599027296912114, 41.1458956888361], [-8.601388396363637, 41.14572087272728], [-8.601711026785715, 41.145711428571424], [-8.603706614173229, 41.14549016929134], [-8.604401177257525, 41.145134056856186], [-8.603446173913044, 41.14551839130435], [-8.604194254658385, 41.14535070186336], [-8.604251341463415, 41.14542358536585], [-8.604580977272727, 41.14529423863637], [-8.604436757142858, 41.14493742857143], [-8.603031333333334, 41.14554361111111], [-8.60307688235294, 41.145581647058826], [-8.603228076923077, 41.14558073076924], [-8.602425520231213, 41.14578508959538], [-8.602064565517242, 41.1456402], [-8.601715665671641, 41.1459823880597], [-8.601935818965517, 41.14690975862067], [-8.602099824489796, 41.1487367877551], [-8.6026455, 41.149817826923076], [-8.60243670967742, 41.15357477419355], [-8.602514872340429, 41.15534936170213], [-8.60291382, 41.1548396], [-8.603466749999999, 41.15326275], [-8.60411659090909, 41.15177959090909], [-8.604463772093023, 41.15094639069768], [-8.604165438202246, 41.15011853932584], [-8.603977923913043, 41.14948666304348], [-8.604926458646617, 41.149677248120305], [-8.6049975, 41.149612499999996], [-8.605889608695652, 41.149828956521745], [-8.606721986577183, 41.150045416107375], [-8.60700853960396, 41.15012783168317], [-8.607227478260867, 41.14994386956522], [-8.60771333121019, 41.14916237579617], [-8.60781295862069, 41.14889255172414], [-8.607964400881057, 41.14848422577093], [-8.607969118421053, 41.14823234210526], [-8.608176769736843, 41.14793445394737], [-8.608437616071429, 41.14747083482142], [-8.609917135394456, 41.147751434968015], [-8.61054429645094, 41.14788479436326], [-8.611205457446808, 41.14712810106384], [-8.611411488431877, 41.146578277634966], [-8.611470093264249, 41.146175308290154], [-8.611434433299898, 41.14594719658977], [-8.611474436619718, 41.146045288732395], [-8.611147382681564, 41.14605660335196], [-8.610862599264708, 41.145973113970584], [-8.610943707236842, 41.14533080427632], [-8.611424574803149, 41.14475900787403], [-8.611339013513515, 41.14473287837838], [-8.611069142045455, 41.1451925625], [-8.61063084860558, 41.14603018326694], [-8.60998544628099, 41.14633693388429], [-8.609271389312976, 41.14671842748091], [-8.609123228571429, 41.14669791428571], [-8.608796513513512, 41.14692340540542], [-8.608745892857144, 41.14709807142857], [-8.608539202846975, 41.14730123487545], [-8.607346968973747, 41.14913838902147], [-8.606830153846152, 41.14913884615385], [-8.606961, 41.148867599999996], [-8.607003607594939, 41.14859684810127], [-8.60639216666667, 41.1484075], [-8.606018647058825, 41.14823537647059], [-8.605362272727273, 41.147958974025975], [-8.604769280487805, 41.14779003658537], [-8.603092862068966, 41.14733927586207], [-8.6028804, 41.147937], [-8.602923272727274, 41.14910427272727], [-8.60420408108108, 41.14948937837838], [-8.60419377777778, 41.14933011111111], [-8.603921605263157, 41.147601039473685], [-8.603885, 41.14646209090908], [-8.605068827586207, 41.14670694827586], [-8.605316543478262, 41.146735891304346], [-8.606093625000002, 41.146916062500004], [-8.607067101818183, 41.14697730545455], [-8.606832579831934, 41.14694488235293], [-8.60670623076923, 41.146895565610855], [-8.60756837837838, 41.14705767567568], [-8.6080704, 41.14727980000001], [-8.608958839694658, 41.147430034351146], [-8.608730069620254, 41.147880892405055], [-8.608453287096774, 41.1480119032258], [-8.60869964516129, 41.147648419354844], [-8.609137099378882, 41.147615683229816], [-8.6095815, 41.14755103448275], [-8.610958752475248, 41.14765312871287], [-8.611184172413793, 41.14650336206897], [-8.611441139240506, 41.14633894936709], [-8.611128, 41.14615109433962], [-8.610811615384616, 41.145800625], [-8.610235945945945, 41.14636256756757], [-8.609254158663882, 41.14688999373695], [-8.608918338129497, 41.146852953237406], [-8.608722582089552, 41.14698380597015], [-8.608355105590062, 41.14779149068323], [-8.6072175, 41.149263477272726], [-8.607029875, 41.148452250000005], [-8.606894727272728, 41.148432440559446], [-8.6064165, 41.148223200000004], [-8.602777923076923, 41.14738776923077], [-8.602626112149531, 41.14721691588785], [-8.6023755, 41.14717681034484], [-8.601734093023255, 41.14718168023256], [-8.602080403846154, 41.147024884615384], [-8.6027895, 41.146759125], [-8.604297, 41.14623027272727], [-8.606765240816326, 41.144864840816325], [-8.607110435207826, 41.1451230806846], [-8.607319761467892, 41.14551075688073], [-8.607249000000001, 41.14566], [-8.60724, 41.145651], [-8.607222, 41.14566], [-8.607222, 41.14566], [-8.607195, 41.145642], [-8.607204, 41.145642], [-8.607213, 41.145642], [-8.60724, 41.145642], [-8.60715, 41.145615], [-8.607069, 41.14575], [-8.606862, 41.146605], [-8.606799, 41.146848000000006], [-8.607321, 41.147082], [-8.608662, 41.147244], [-8.608743000000002, 41.147388], [-8.608014, 41.148315], [-8.60742, 41.14953], [-8.607303000000002, 41.14989], [-8.606511, 41.150943], [-8.605287, 41.15268], [-8.604855, 41.153814], [-8.604765, 41.154381], [-8.604738, 41.155713], [-8.604585, 41.157738], [-8.60445, 41.159862], [-8.602488, 41.159727], [-8.599716, 41.159124], [-8.597385, 41.159331], [-8.594541, 41.160231], [-8.591121, 41.162049], [-8.589699, 41.163741], [-8.58969, 41.163777], [-8.589033, 41.164794], [-8.588016, 41.167305], [-8.58672, 41.169969], [-8.585208, 41.172894], [-8.583894, 41.174163], [-8.582175000000001, 41.175306], [-8.579547, 41.177016], [-8.576784, 41.177799], [-8.574903, 41.177403], [-8.575776, 41.175423], [-8.575362000000002, 41.174253], [-8.573949, 41.174082], [-8.572896, 41.174244], [-8.572626, 41.174316000000005], [-8.573832, 41.173173], [-8.572914, 41.172273], [-8.573958, 41.171616], [-8.573931, 41.170779], [-8.573463, 41.170833], [-8.573499000000002, 41.170851], [-8.574003, 41.170617], [-8.573634, 41.171724], [-8.573328, 41.172111], [-8.5734, 41.172876], [-8.572995, 41.173911], [-8.572518, 41.174559], [-8.573778, 41.174262], [-8.575398, 41.174298], [-8.576316, 41.174028], [-8.577414, 41.17311], [-8.577612, 41.173038], [-8.577612, 41.173047], [-8.577612, 41.173029], [-8.577603, 41.17302], [-8.577603, 41.173029], [-8.577594, 41.173038], [-8.577585, 41.173047], [-8.57763, 41.173029], [-8.57763, 41.17302], [-8.578287, 41.172453000000004], [-8.578971, 41.171679], [-8.578593, 41.170824], [-8.57934, 41.169465], [-8.579826, 41.168259], [-8.579853, 41.168286], [-8.579862, 41.168277], [-8.579907, 41.168133], [-8.581104, 41.168664], [-8.581329, 41.169915], [-8.581509, 41.170779], [-8.582445, 41.171274], [-8.583552, 41.170392], [-8.585127, 41.170203], [-8.586288, 41.170554], [-8.586297, 41.170563], [-8.587611, 41.170923], [-8.588034000000002, 41.171634], [-8.586657, 41.174091], [-8.585361, 41.176701], [-8.583885, 41.179248], [-8.583066, 41.180931], [-8.582499, 41.180679], [-8.582553, 41.180535], [-8.582211, 41.180238], [-8.582625, 41.178501], [-8.583588, 41.176251], [-8.584407, 41.174334], [-8.58366, 41.173614], [-8.584236, 41.172507], [-8.58366, 41.172228], [-8.582895, 41.172183], [-8.582445, 41.17123800000001], [-8.582895, 41.172183], [-8.582445, 41.17123800000001]], coordinates_unit='degrees'),
            Route([[-8.639847, 41.159826], [-8.640351, 41.159871], [-8.642196, 41.160114], [-8.644455, 41.160492], [-8.646921, 41.160951], [-8.649999, 41.161491], [-8.653167, 41.162031], [-8.656434, 41.16258], [-8.660178, 41.163192], [-8.663112, 41.163687], [-8.666235, 41.1642], [-8.669169, 41.164704], [-8.670852, 41.165136], [-8.670942, 41.166576], [-8.66961, 41.167962], [-8.668098, 41.168988000000006], [-8.66664, 41.170005], [-8.665767, 41.170635000000004], [-8.66574, 41.170671], [-8.665686, 41.170626], [-8.665677, 41.170653], [-8.664786, 41.171319], [-8.663238, 41.172453000000004], [-8.66205, 41.173875], [-8.662248, 41.175378], [-8.663733, 41.176413], [-8.663751, 41.17725], [-8.663229, 41.177754], [-8.66322, 41.177763], [-8.66322, 41.177763], [-8.662986, 41.17779], [-8.661771, 41.176773], [-8.6589, 41.177169], [-8.656083, 41.177772], [-8.65512, 41.177898], [-8.653248, 41.178708], [-8.652699, 41.180409], [-8.653203, 41.182677000000005], [-8.653302, 41.183631000000005], [-8.653806, 41.185359], [-8.654166, 41.18697], [-8.654328, 41.187816], [-8.654337, 41.187816], [-8.654337, 41.187816], [-8.582895, 41.172183], [-8.582445, 41.17123800000001]], coordinates_unit='degrees'),
            Route([[-8.618643, 41.141412], [-8.618499, 41.141376], [-8.620326, 41.14251], [-8.622153, 41.143815], [-8.623953, 41.144373], [-8.62668, 41.144778], [-8.627373, 41.144697], [-8.630226, 41.14521], [-8.632746, 41.14692], [-8.631738, 41.148225], [-8.629938, 41.150385], [-8.62911, 41.151213], [-8.629128, 41.15124], [-8.628786, 41.152203], [-8.628687, 41.152374], [-8.628759, 41.152518], [-8.630838000000002, 41.15268], [-8.632323000000001, 41.153022], [-8.631144, 41.154489], [-8.630829, 41.154507], [-8.630829, 41.15451600000001], [-8.630829, 41.154498], [-8.630838000000002, 41.154489], [-8.630784, 41.154795], [-8.631135, 41.154534], [-8.631126, 41.154543], [-8.631099, 41.154552], [-8.631108, 41.15457], [-8.631108, 41.154579], [-8.63145, 41.154309], [-8.632548, 41.152491], [-8.634888, 41.151186], [-8.638344, 41.150133], [-8.642457, 41.149431], [-8.644725, 41.151294], [-8.642484, 41.15151], [-8.640918, 41.149458], [-8.640198, 41.146614], [-8.639622, 41.143923], [-8.641062, 41.142627], [-8.641953, 41.142564], [-8.642142, 41.141376], [-8.642295, 41.140872], [-8.642304, 41.140872], [-8.642304, 41.140881], [-8.642304, 41.140881], [-8.642295, 41.140881], [-8.642295, 41.140881], [-8.642304, 41.1408], [-8.642817000000003, 41.140053], [-8.644302000000001, 41.140341], [-8.646003, 41.141169], [-8.647506, 41.142267], [-8.647776, 41.142465], [-8.647794, 41.142501], [-8.647821, 41.142537], [-8.647893, 41.142618], [-8.647857, 41.142618], [-8.647857, 41.142618], [-8.647857, 41.142609], [-8.647866, 41.142618], [-8.647875, 41.142609], [-8.582895, 41.172183], [-8.582445, 41.17123800000001]], coordinates_unit='degrees')
        ]
        self.ground_truth_routes_4 = [
            Route([[-8.639703, 41.159781], [-8.639757, 41.159754], [-8.639775, 41.159727], [-8.639901, 41.159655], [-8.640522, 41.15979], [-8.640513, 41.159808], [-8.640522, 41.159817], [-8.640702, 41.159565], [-8.641098, 41.15819700000001], [-8.641539, 41.156865], [-8.642151, 41.154939], [-8.642988, 41.15421], [-8.645049000000002, 41.154381], [-8.646876, 41.154264], [-8.649657, 41.154084000000005], [-8.651187, 41.152887], [-8.653356000000002, 41.152122], [-8.656236, 41.151618], [-8.658414000000002, 41.150934], [-8.659152, 41.15223]], coordinates_unit='degrees')
        ]
        self.input_routes_4 = [
            Route([[-8.640300192994875, 41.159787563133406], [-8.640511196927717, 41.15936689916726], [-8.640722198152044, 41.15894623481606], [-8.640933196667968, 41.15852557007982], [-8.641091384731634, 41.15809196853128], [-8.641249570702344, 41.15765836676632], [-8.641407754580301, 41.157224764784964], [-8.64154977731084, 41.15678800309613], [-8.641691798148713, 41.15635124123286], [-8.641833817094032, 41.15591447919516], [-8.641975834146795, 41.15547771698302], [-8.642117849306999, 41.15504095459647], [-8.642487614366994, 41.154687849045025], [-8.642857375443409, 41.154334742311164], [-8.643454347804841, 41.154347346476115], [-8.644051320395782, 41.15435994755907], [-8.64464829321623, 41.15437254556004], [-8.645244254170638, 41.154343511456396], [-8.645840214597124, 41.15431447428118], [-8.646436174495586, 41.154285434034435], [-8.647031332013688, 41.15424821906705], [-8.647626488855986, 41.154211001036394], [-8.64822164502248, 41.15417377994249], [-8.648816800513066, 41.154136555785314], [-8.649411955327748, 41.15409932856489], [-8.649854295757901, 41.15379722350983], [-8.650296632111143, 41.15349511676265], [-8.650738964387473, 41.15319300832338], [-8.651181292586893, 41.152890898192034], [-8.651721859220467, 41.15269977880973], [-8.65226242270219, 41.152508656900395], [-8.652802983032057, 41.152317532464025], [-8.653343540210173, 41.152126405500674], [-8.65392509360158, 41.15202419273908], [-8.654506645179616, 41.15192197705268], [-8.655088194944174, 41.15181975844151], [-8.655669742895256, 41.151717536905586], [-8.656228132270584, 41.15155811305489], [-8.656786518930279, 41.15139868650776], [-8.657344902874238, 41.15123925726424], [-8.65790328410246, 41.15107982532433], [-8.6582812439593, 41.15142796452223], [-8.658659207830151, 41.151776102484725]], coordinates_unit='degrees')
        ]

    def test_calculate_ratio_of_point_count(self):
        utility_values = td.calculate_ratio_of_point_count(self.input_routes, self.ground_truth_routes,
                                                           self.grid_origin, self.grid_width, self.width_per_cell)
        self.assertEqual([[50, 100, 0]], utility_values['point'])
        self.assertEqual([50], utility_values['route'])
        self.assertEqual(50, utility_values['dataset'])

        utility_values = td.calculate_ratio_of_point_count(self.ground_truth_routes, self.ground_truth_routes,
                                                           self.grid_origin, self.grid_width, self.width_per_cell)
        self.assertEqual([[100, 100, 100]], utility_values['point'])
        self.assertEqual([100], utility_values['route'])
        self.assertEqual(100, utility_values['dataset'])

        utility_values = td.calculate_ratio_of_point_count(self.input_routes_3, self.ground_truth_routes_3)
        for route_value in utility_values['route']:
            self.assertLessEqual(route_value, 100)
        for route in utility_values['point']:
            for point_value in route:
                self.assertLessEqual(point_value, 100)
        self.assertLessEqual(utility_values['dataset'], 100)
        for route_idx, route in enumerate(self.input_routes_3):
            self.assertEqual(len(route), len(utility_values['point'][route_idx]))

        utility_values = td.calculate_ratio_of_point_count(self.input_routes_4, self.ground_truth_routes_4)
        for route_idx, route in enumerate(self.input_routes_4):
            self.assertEqual(len(route), len(utility_values['point'][route_idx]))

    def test_calculate_ratio_of_desired_point_count(self):
        utility_values = td.calculate_ratio_of_desired_point_count(self.input_routes_2,
                                                                   self.ground_truth_routes_2,
                                                                   self.grid_origin, self.grid_width,
                                                                   self.width_per_cell, self.desired_point_count)
        self.assertEqual([[10., 10., 0.], [10., 0., 0., 0., 0., 20., 20., 0.]], utility_values['point'])
        self.assertEqual([20. / 3, 30. / 5], utility_values['route'])
        self.assertAlmostEqual(50. / 9, utility_values['dataset'], places=5)

        utility_values = td.calculate_ratio_of_desired_point_count(self.ground_truth_routes_2,
                                                                   self.ground_truth_routes_2,
                                                                   self.grid_origin, self.grid_width,
                                                                   self.width_per_cell, self.desired_point_count)
        expected_point = [[20., 20., 10.], [10., 50., 50., 50., 50., 50., 30., 30., 30.]]
        expected_route = [15., 30.]
        actual_point = utility_values['point']
        actual_route = utility_values['route']
        for route_idx, route in enumerate(expected_point):
            self.assertAlmostEqual(expected_route[route_idx], actual_route[route_idx])
            for point_idx, _ in enumerate(route):
                self.assertAlmostEqual(expected_point[route_idx][point_idx], actual_point[route_idx][point_idx],
                                       places=5)
        self.assertAlmostEqual(40. / 3, utility_values['dataset'], places=5)

        utility_values = td.calculate_ratio_of_desired_point_count(
            self.empty_routes, self.ground_truth_routes_2, self.grid_origin, self.grid_width, self.width_per_cell,
            self.desired_point_count)
        self.assertEqual(0, utility_values['dataset'])
        self.assertEqual([0, 0], utility_values['route'])
        self.assertEqual([[], []], utility_values['point'])

        utility_values = td.calculate_ratio_of_desired_point_count(
            self.input_routes_2, self.empty_routes, self.grid_origin, self.grid_width, self.width_per_cell,
            self.desired_point_count)
        self.assertEqual(0, utility_values['dataset'])
        self.assertEqual([0, 0], utility_values['route'])
        self.assertEqual([[0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0]], utility_values['point'])

        utility_values = td.calculate_ratio_of_desired_point_count(self.ground_truth_routes_3,
                                                                   self.input_routes_3)
        for route_value in utility_values['route']:
            self.assertLessEqual(route_value, 100)
        for route in utility_values['point']:
            for point_value in route:
                self.assertLessEqual(point_value, 100)
        self.assertLessEqual(utility_values['dataset'], 100)

        with self.assertRaises(Exception) as context:
            td.calculate_ratio_of_desired_point_count(self.input_routes_2, [], self.grid_origin,
                                                      self.grid_width, self.nr_cells_per_row,
                                                      self.desired_point_count)
            self.assertTrue('Routes are empty' in context.exception)

        with self.assertRaises(Exception) as context:
            td.calculate_ratio_of_desired_point_count(self.input_routes_2, self.ground_truth_routes,
                                                      self.grid_origin, self.grid_width, self.nr_cells_per_row,
                                                      self.desired_point_count)
            self.assertTrue('Number of input routes and ground truth routes needs to be the same' in context.exception)
